﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Shapes;

namespace ReactiveTriangles
{
    class Program
    {        
        [STAThread]
        static void Main(string[] args)
        {
            Random rnd = new Random();
            
            // vytvori okno, jehoz root element je Canvas
            Window w = new Window() { Title = "Reactive Triangles" };
            Canvas canvas = new Canvas() { Background = Brushes.AliceBlue };
            w.Content = canvas;

            // vytvori pozorovatelnou s body kliknuti mysi
            var mouseClicks = Observable
                .FromEvent<MouseButtonEventArgs>(w, "MouseLeftButtonDown")
                .Select(e => e.EventArgs.GetPosition(canvas));

            // oznaci kazdy bod kliknuti teckou (malou elipsou)
            mouseClicks.Subscribe(p =>
            {
                Console.WriteLine("Clicked at {0}!", p);
                Ellipse e = new Ellipse() { Fill = Brushes.Black, Opacity = 0.3, Width = 4, Height = 4 };
                Canvas.SetLeft(e, (double)p.X - 2);
                Canvas.SetTop(e, (double)p.Y - 2);
                canvas.Children.Add(e);
            });

            // kazde 3 kliknuti vytvori trojuhelnik
            mouseClicks.BufferWithCount(3).Subscribe(pts =>
            {
                Console.WriteLine("Creating triangle!");
                byte[] color = new byte[3];
                rnd.NextBytes(color);
                canvas.Children.Add(new Polygon() { Points = new PointCollection(pts), Opacity = 0.5, Fill = new SolidColorBrush(Color.FromArgb(0xFF, color[0], color[1], color[2])) });
            });

            // ukaze modalni dialog
            w.ShowDialog();
        }
    }
}
